#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    Copy
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct BigQueryChannelNameComponent {
    #[serde(rename = "includeProject")]
    include_project: bool,
    #[serde(rename = "includeDataset")]
    include_dataset: bool,
    #[serde(rename = "includeTable")]
    include_table: bool,
}
impl BigQueryChannelNameComponent {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        include_project: bool,
        include_dataset: bool,
        include_table: bool,
    ) -> Self {
        Self::builder()
            .include_project(include_project)
            .include_dataset(include_dataset)
            .include_table(include_table)
            .build()
    }
    /// Whether to include the project name in the channel name.
    #[inline]
    pub fn include_project(&self) -> bool {
        self.include_project
    }
    /// Whether to include the dataset name in the channel name.
    #[inline]
    pub fn include_dataset(&self) -> bool {
        self.include_dataset
    }
    /// Whether to include the table name in the channel name.
    #[inline]
    pub fn include_table(&self) -> bool {
        self.include_table
    }
}
